summaryrefslogtreecommitdiff
path: root/test
diff options
context:
space:
mode:
authorLennart Poettering <lennart@poettering.net>2023-02-16 16:31:02 +0100
committerLennart Poettering <lennart@poettering.net>2023-02-17 09:55:35 +0100
commitdd131fcf8c4903138755b201e7d5c68206f60638 (patch)
tree527d007b5086d16fd9844ea883da2ce0b98d4547 /test
parentc4ef4df41728435dc3bf3c192281aa17fde2be3f (diff)
downloadsystemd-dd131fcf8c4903138755b201e7d5c68206f60638.tar.gz
test: add test for new "systemctl --kill-value=" functionality
(as side-effect this also tests the new systemd-notify --exec switch)
Diffstat (limited to 'test')
l---------test/TEST-78-SIGQUEUE/Makefile1
-rwxr-xr-xtest/TEST-78-SIGQUEUE/test.sh10
-rw-r--r--test/units/testsuite-78.service7
-rwxr-xr-xtest/units/testsuite-78.sh36
4 files changed, 54 insertions, 0 deletions
diff --git a/test/TEST-78-SIGQUEUE/Makefile b/test/TEST-78-SIGQUEUE/Makefile
new file mode 120000
index 0000000000..e9f93b1104
--- /dev/null
+++ b/test/TEST-78-SIGQUEUE/Makefile
@@ -0,0 +1 @@
+../TEST-01-BASIC/Makefile \ No newline at end of file
diff --git a/test/TEST-78-SIGQUEUE/test.sh b/test/TEST-78-SIGQUEUE/test.sh
new file mode 100755
index 0000000000..61e8e7d1c4
--- /dev/null
+++ b/test/TEST-78-SIGQUEUE/test.sh
@@ -0,0 +1,10 @@
+#!/usr/bin/env bash
+# SPDX-License-Identifier: LGPL-2.1-or-later
+set -e
+
+TEST_DESCRIPTION="Test queue signal logic"
+
+# shellcheck source=test/test-functions
+. "$TEST_BASE_DIR/test-functions"
+
+do_test "$@"
diff --git a/test/units/testsuite-78.service b/test/units/testsuite-78.service
new file mode 100644
index 0000000000..05f3effdb6
--- /dev/null
+++ b/test/units/testsuite-78.service
@@ -0,0 +1,7 @@
+# SPDX-License-Identifier: LGPL-2.1-or-later
+[Unit]
+Description=TEST-78-SIGQUEUE
+
+[Service]
+Type=oneshot
+ExecStart=/usr/lib/systemd/tests/testdata/units/%N.sh
diff --git a/test/units/testsuite-78.sh b/test/units/testsuite-78.sh
new file mode 100755
index 0000000000..1680166553
--- /dev/null
+++ b/test/units/testsuite-78.sh
@@ -0,0 +1,36 @@
+#!/usr/bin/env bash
+# SPDX-License-Identifier: LGPL-2.1-or-later
+set -ex
+set -o pipefail
+
+if ! env --block-signal=SIGUSR1 true 2> /dev/null ; then
+ echo "env tool too old, can't block signals, skipping test." >&2
+ echo OK >/testok
+ exit 0
+fi
+
+systemd-analyze log-level debug
+
+UNIT="test-sigqueue-$RANDOM.service"
+
+systemd-run -u "$UNIT" -p Type=notify -p DynamicUser=1 -- env --block-signal=SIGRTMIN+7 systemd-notify --exec --ready \; sleep infinity
+
+systemctl kill --kill-whom=main --kill-value=4 --signal=SIGRTMIN+7 "$UNIT"
+systemctl kill --kill-whom=main --kill-value=4 --signal=SIGRTMIN+7 "$UNIT"
+systemctl kill --kill-whom=main --kill-value=7 --signal=SIGRTMIN+7 "$UNIT"
+systemctl kill --kill-whom=main --kill-value=16 --signal=SIGRTMIN+7 "$UNIT"
+systemctl kill --kill-whom=main --kill-value=32 --signal=SIGRTMIN+7 "$UNIT"
+systemctl kill --kill-whom=main --kill-value=16 --signal=SIGRTMIN+7 "$UNIT"
+
+# We simply check that six signals are queued now. There's no easy way to check
+# from shell wich ones those are, hence we don't check that.
+P=$(systemctl show -P MainPID "$UNIT")
+
+test "$(grep SigQ: /proc/"$P"/status | cut -d: -f2 | cut -d/ -f1)" -eq 6
+
+systemctl stop $UNIT
+
+systemd-analyze log-level info
+echo OK >/testok
+
+exit 0